<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Dialog demo</title>
  <style>
    ._dialog-open {
      overflow: hidden;
    }

    ._dialog-open ._dialog {
      overflow-x: hidden;
      overflow-y: auto;
    }

    ._dialog {
      position: fixed;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      overflow: hidden;
      outline: 0;
      display: flex;
      flex-direction: column;
      justify-content: flex-start;
      align-items: center;
      background-color: rgba(63, 69, 74, 0.75);
    }

    ._dialog-body {
      position: relative;
      width: 600px;
      padding: .75rem;
      margin: 0 .5rem .5rem .5rem;
      pointer-events: auto;
      background-color: #fff;
      background-clip: padding-box;
      border-radius: 0 0 4px 4px;
      outline: 0;
      opacity: 1;
    }

    ._dialog-body-grow {
      width: calc(100vw - 2rem);
    }

    ._dialog-close {
      position: fixed;
      top: .5rem;
      right: .75rem;
      border: 0;
      outline: 0;
      transition: none;
      font-size: 1.5rem;
      font-weight: bold;
      text-shadow: 0 0 4px rgba(63, 69, 74, 1);
      line-height: 1;
      color: #fff;
      background-color: transparent;
    }

    ._dialog-close>span {
      pointer-events: none;
    }

    ._fade-in {
      animation: animate-fade-in ease-in 300ms;
      animation-iteration-count: 1;
      animation-fill-mode: forwards;
    }

    ._fade-out {
      animation: animate-fade-out ease-out 300ms;
      animation-iteration-count: 1;
      animation-fill-mode: forwards;
    }

    ._drop-from-above {
      animation: animate-drop-from-above ease-in 200ms;
      animation-iteration-count: 1;
      animation-fill-mode: forwards;
    }

    ._pull-above {
      animation: animate-pull-above ease-out 300ms;
      animation-iteration-count: 1;
      animation-fill-mode: forwards;
    }

    @keyframes animate-pull-above {
      0% {
        transform: translateY(0);
      }
      100% {
        transform: translateY(-100vh);
      }
    }

    @keyframes animate-drop-from-above {
      0% {
        transform: translateY(-100vh);
      }
      100% {
        transform: translateY(0);
      }
    }

    @keyframes animate-fade-in {
      0% {
        opacity: 0;
        visibility: hidden;
      }
      100% {
        opacity: 1;
        visibility: visible;
      }
    }

    @keyframes animate-fade-out {
      0% {
        opacity: 1;
        visibility: visible;
      }
      100% {
        opacity: 0;
        visibility: hidden;
      }
    }

    ._d-none {
      display: none;
    }

    @media (max-width: calc(600px + 2rem)) {
      ._dialog-body {
        width: calc(100vw - 2rem);
      }
    }
  </style>
</head>

<body>
  <button id="show1" data-toggle="dialog">Show default</button>

  <button id="show2" data-toggle="dialog">Show with options</button>

  <button id="show3" data-toggle="dialog">Show existing</button>

  <div id="existing-dialog" class="_dialog _d-none _fade-out" tabindex="-1" role="dialog" style="z-index: 1050">
    <button class="_dialog-close" type="button" data-dismiss="dialog" aria-label="Close" style="z-index: 1051">
      <span aria-hidden="true">×</span>
    </button>
    <div class="_dialog-body _pull-above" role="document">
      <p>Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel augue laoreet rutrum
        faucibus dolor auctor.</p>
      <p>Aenean lacinia bibendum nulla sed consectetur. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.
        Donec sed odio dui. Donec ullamcorper nulla non metus auctor fringilla.</p>
      <p>Cras mattis consectetur purus sit amet fermentum. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Morbi
        leo risus, porta ac consectetur ac, vestibulum at eros.</p>
      <p>Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Vivamus sagittis lacus vel augue laoreet rutrum
        faucibus dolor auctor.</p>
    </div>
  </div>

  <script>
    const Dialog = ({
      large = false,
      z = 1050,
      remove = true,
    } = {}) => {
      const calcZ = z => {
        if (Number(z) !== 1050) {
          return Number(z)
        }
        if (isNaN(Number(z))) {
          return 1050
        }
        const dialogs = document.querySelectorAll('[role="dialog"]')
        if (dialogs.length > 0) {
          return 1050 + (dialogs.length * 2)
        }
        return 1050
      }

      const hidden = dialog => {
        const ev = new Event('dialog.hidden')
        dialog.dispatchEvent(ev)
      }
      const hiding = dialog => {
        const ev = new Event('dialog.hiding')
        dialog.dispatchEvent(ev)
      }
      const removed = dialog => {
        const ev = new Event('dialog.removed')
        dialog.dispatchEvent(ev)
      }
      const showing = dialog => {
        const ev = new Event('dialog.showing')
        dialog.dispatchEvent(ev)
      }
      const shown = dialog => {
        const ev = new Event('dialog.shown')
        dialog.dispatchEvent(ev)
      }

      const registerEvents = dialog => {
        showing(dialog)
        dialog.addEventListener('mouseup', hide, { passive: true, capture: false })
      }

      const s2h = s => document.createRange().createContextualFragment(s.trim())
      const skeleton = () => {
        if (!calcZ(z)) {
          return
        }
        return s2h(`
      <div class="_dialog" tabindex="-1" role="dialog" style="z-index: ${calcZ(z)}">
        <button class="_dialog-close" type="button" data-dismiss="dialog" aria-label="Close" style="z-index: ${calcZ(z) + 1}"><span aria-hidden="true">&times;</span></button>
        <div class="_dialog-body ${large && '_dialog-body-grow'}" role="document"></div>
      </div>
    `)
      }
      const convert = c =>
        c.nodeType > 0 ? c : s2h(c)

      const inject = content => {
        const fragment = skeleton()
        if (!fragment) {
          return
        }
        const node = fragment.firstChild
        node.querySelector('[role=document]').appendChild(convert(content))
        return node
      }

      const hide = e => {
        if (!(e.target.matches('._dialog') || e.target.matches('[data-dismiss=dialog]'))) {
          return
        }
        const dialog = e.target.closest('[role=dialog]')
        const dialogBody = dialog.querySelector('[role=document]')
        dialog.classList.remove('_fade-in')
        dialogBody.classList.remove('_drop-from-above')
        dialog.classList.add('_fade-out')
        dialogBody.classList.add('_pull-above')
        hiding(dialog)
        remove ?
          setTimeout(() => {
            dialog.remove()
            removed(dialog)
          }, 300) :
          setTimeout(() => {
            dialog.classList.add('_d-none')
            hidden(dialog)
          }, 300)
        const body = document.querySelector('body')
        body.classList.remove('_dialog-open')
        return
      }

      const show = dialog => {
        if (!dialog) {
          return 'error'
        }
        if (!document.contains(dialog)) {
          document.querySelector('body').appendChild(dialog)
        }
        registerEvents(dialog)
        const body = document.querySelector('body')
        body.classList.add('_dialog-open')
        const dialogBody = dialog.querySelector('[role=document]')
        dialog.classList.remove('_d-none', '_fade-out')
        dialogBody.classList.remove('_pull-above')
        dialog.classList.add('_fade-in')
        dialogBody.classList.add('_drop-from-above')
        setTimeout(() => {
          shown(dialog)
        }, 300)
        return 'success'
      }

      return {
        inject,
        show,
        skeleton: () => skeleton().firstChild,
      }
    }

    // default options
    const basicDialog = Dialog()

    // custom options
    const customDialog = Dialog({ large: true, z: 1000, remove: false })

    // inject string
    const myDialog1 = basicDialog.inject('<p>Content of my first dialog</p>')

    // inject node
    const myNode = document.createElement('p')
    myNode.textContent = 'Content of my second dialog'
    const myDialog2 = customDialog.inject(myNode)

    document.getElementById('show1')
      .addEventListener(
        'mouseup',
        () => {
          basicDialog.show(myDialog1)
        },
        { passive: true, capture: false }
      )

    document.getElementById('show2')
      .addEventListener(
        'mouseup',
        () => {
          customDialog.show(myDialog2)
        },
        { passive: true, capture: false }
      )

    const existingDialog = document.getElementById('existing-dialog')

    document.getElementById('show3')
      .addEventListener(
        'mouseup',
        () => {
          customDialog.show(existingDialog)
        },
        { passive: true, capture: false }
      )
  </script>

</body>

</html>